/*
Scrivere una funzione 
int* FindVal(int a[], int len, int val) 
che, dato un array a e la sua lunghezza len, cerca il valore val
all'interno di a e restituisce un puntatore ad un elemento di a che lo 
contiene, o la costante predefinita NULL se val non è contenuto in a.
Eseguire dei test con un array riempito di elementi casuali
*/

#include <stdio.h>
#include <time.h>
#define N 10

int* FindVal(int a[], int len, int val)
{
	int i=0, trovato=0;
	int *p = NULL;
	while(i<len && !trovato)
	{
		if (a[i] == val){
			trovato = 1;
			p = &a[i];
		}
		i++;
	}
	return p;
}


int main()
{
	/* inizializzazione del generatore di numeri pseudo-casuali */
	srand(time(NULL));
	
	int a[N];
	int i, x;
	int *val;
	for(i=0; i<N; i++){
		a[i] = rand()%101;
		printf("A[%d]=%d\n", i, a[i]);
	}

	printf("Inserisci un valore di test:\n");
	scanf("%d",&x);
	
	val = FindVal(a, N, x);
	if (val == NULL) printf("Il valore non è stato trovato\n");
	else printf("Il valore %d è stato trovato all'indirizzo %p\n", *val, val);

	return 0;
}